#include <windows.h>
#pragma comment(lib, "winmm.lib")	// for mci...()
#include "resource.h"

HINSTANCE hInst;

HWND MainWnd;
HWND EditWnd;
HWND ResultWnd;
HWND ErrorWnd;

LRESULT CALLBACK EditHookProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static WNDPROC pre;
	switch(msg)
	{
	case WM_USER:
		pre = (WNDPROC)GetWindowLong(hWnd, GWL_WNDPROC);
		break;
	case WM_KEYDOWN:
		switch(wParam)
		{
		case VK_RETURN:
		case VK_ESCAPE:
			PostMessage(MainWnd, msg, wParam, lParam);
			return pre(hWnd, msg, wParam, lParam);
		default:
			return pre(hWnd, msg, wParam, lParam);
		}
	default:
		return pre(hWnd, msg, wParam, lParam);
	}

	return 0;
}

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_SIZE:
		{
			RECT rect;

			GetClientRect(MainWnd, &rect);

			SetWindowPos(EditWnd, 0, 0, 0, rect.right, rect.bottom / 3, SWP_NOZORDER);
			SetWindowPos(ResultWnd, 0, 0, rect.bottom / 3, rect.right, rect.bottom / 3, SWP_NOZORDER);
			SetWindowPos(ErrorWnd, 0, 0, rect.bottom / 3 * 2, rect.right, rect.bottom / 3, SWP_NOZORDER);
		}
		break;
	case WM_GETMINMAXINFO:
		{
			LPMINMAXINFO lpmmi = (LPMINMAXINFO)lParam;
			RECT rect;

			ZeroMemory(&rect, sizeof(RECT));
			AdjustWindowRect(&rect, WS_OVERLAPPEDWINDOW, FALSE);
			/*// ShowRect(debug)
			{
				char tmp[256];
				wsprintf(tmp, "%d,%d - %d,%d", rect.left, rect.top, rect.right, rect.bottom);
				MessageBox(NULL, tmp, "RECT", MB_OK);
			}*/

			lpmmi->ptMaxSize.y = rect.bottom - rect.top + 75;
			lpmmi->ptMaxTrackSize.y = rect.bottom - rect.top + 75;
			lpmmi->ptMinTrackSize.y = rect.bottom - rect.top + 75;
		}
		break;
	case WM_KEYDOWN:
		switch(wParam)
		{
		case VK_RETURN:
			{
				char mcistr[256 + 1];
				char mcierrstr[256 + 1];
				char tmp[256 + 1];
				int result;

				GetWindowText(EditWnd, mcistr, sizeof(mcistr));
				result = mciSendString(mcistr, mcistr, sizeof(mcistr), NULL);
				wsprintf(tmp, "ERRCODE=%d RETURN_STR=\"%s\"", result, mcistr);
				SetWindowText(ResultWnd, tmp);
				mciGetErrorString(result, mcierrstr, sizeof(mcierrstr));
				SetWindowText(ErrorWnd, mcierrstr);
				if(!result)
					SetWindowText(EditWnd, NULL);
			}
			break;
		case VK_ESCAPE:
			PostMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		default:
			return DefWindowProc(hWnd, msg, wParam, lParam);
		}
		break;
	case WM_CLOSE:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, msg, wParam, lParam);
	}

	return 0;
}

BOOL makeWindow(int nCmdShow)
{
	WNDCLASS wc;

	// NULL is Null"Pointer", not Zero. Okay?

	ZeroMemory(&wc, sizeof(WNDCLASS));	// abone!
	wc.lpszClassName = "MCITEST_MAINWND";
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.hCursor = (HCURSOR)LoadImage(NULL, MAKEINTRESOURCE(IDC_ARROW), IMAGE_CURSOR, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
	wc.style = CS_HREDRAW | CS_VREDRAW;;
	wc.lpfnWndProc = MainWndProc;
	wc.hInstance = hInst;
	wc.hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_MAINICON));
	if(!RegisterClass(&wc))
	{
		MessageBox(NULL, "RegisterClass failed.", "Oops!", MB_ICONERROR | MB_OK);
		return TRUE;
	}

	if(!(MainWnd = CreateWindow(wc.lpszClassName, "mciSendString Test: Enter=Exec, ESC=Quit.", WS_SYSMENU | WS_MINIMIZEBOX | WS_THICKFRAME,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
		NULL, (HMENU)NULL, hInst, 0)))
	{
		MessageBox(NULL, "CreateWindow(MainWnd) failed.", "Oops!", MB_ICONERROR | MB_OK);
		return TRUE;
	}

	if(!(EditWnd = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD | WS_VISIBLE,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, 
		MainWnd, (HMENU)NULL, hInst, 0)))
	{
		MessageBox(NULL, "CreateWindow(EditWnd) failed.", "Oops!", MB_ICONERROR | MB_OK);
		return TRUE;
	}

	if(!(ResultWnd = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD | WS_VISIBLE | WS_DISABLED | WS_BORDER,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, 
		MainWnd, (HMENU)NULL, hInst, 0)))
	{
		MessageBox(NULL, "CreateWindow(ResultWnd) failed.", "Oops!", MB_ICONERROR | MB_OK);
		return TRUE;
	}

	if(!(ErrorWnd = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD | WS_VISIBLE | WS_DISABLED | WS_BORDER,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, 
		MainWnd, (HMENU)NULL, hInst, 0)))
	{
		MessageBox(NULL, "CreateWindow(ErrorWnd) failed.", "Oops!", MB_ICONERROR | MB_OK);
		return TRUE;
	}

	EditHookProc(EditWnd, WM_USER, 0, 0);
	SetWindowLong(EditWnd, GWL_WNDPROC, (LONG)EditHookProc);

	ShowWindow(MainWnd, nCmdShow);

	return FALSE;
}

int pump()
{
	MSG msg;

	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;	// PostQuitMessage's parameter = AppQuitCode.
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
	hInst = hInstance;

	if(makeWindow(nShowCmd))
		return 1;	// I can do nothing! Die bitch!

	return pump();	// Return AppQuitCode. Have a nice day!
}
